/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package reprezentaciagrafu_2;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 *
 * @author majer
 */
public class Graf 
{
    private int aN; // pocet vrcholov
    private int aM; // pocet hran
    private int[][] aH; // pole hran
    
    public Graf( int paPocetVrcholov, int paPocetHran )
    {
        aN = paPocetVrcholov;
        aM = paPocetHran;
        aH = new int[1+2][1+aM];
    }
    
    public static Graf nacitajGraf( String paNazovSuboru) 
            throws FileNotFoundException
    {
        Scanner s = new Scanner( new File(paNazovSuboru));
        int pocetVrcholov = s.nextInt();
        int pocetHran = s.nextInt();
        Graf g = new Graf(pocetVrcholov,pocetHran);
        for (int j = 1; j <= pocetHran; j++ )
        {
            int u = s.nextInt();
            int v = s.nextInt();
            
            g.aH[1][j] = u;
            g.aH[2][j] = v;
        }
        return g;
    }
    
    public void vypis()
    {
        System.out.println("Pocet vrcholov: " + aN);
        System.out.println("Pocet hran: " + aM);
        System.out.println("Hrany: ");
        for (int i = 1; i <= 2; i++)
        {
            for (int j = 1; j <= aM; j++)
            {
                System.out.print(" " + aH[i][j] );
            }
            System.out.println();
        }
    }
    
    public void vypis2()
    {
        System.out.println("G=(V,H)");
        
        System.out.print("V={");
        for ( int i = 1; i <= aN; i++ )
        {
            if (i == 1) System.out.print("" + i);
            else System.out.print("," + i);
        }
        System.out.println("}");
        
        System.out.print("H={");
        for (int j = 1; j <= aM; j++)
        {
            if (j > 1) System.out.print(",");
            System.out.print("{" + aH[1][j] + "," + 
                    aH[2][j] + "}" );
        }
        System.out.println("}");
    }
    
    public int stupenVrchola(int v)
    {
        // pocet incidentnych hran
        int pocet = 0;
        for (int j = 1; j <= aM; j++)
        {
            if (aH[1][j] == v || aH[2][j] == v)
            {
                // mam incidentnu hranu
                pocet++;
            }
        }
        return pocet;
    }
    
    public void vypisIncidentneHrany(int v)
    {
        for (int j = 1; j <= aM; j++)
        {
            if (aH[1][j] == v || aH[2][j] == v)
            {
                // mam incidentnu hranu
                System.out.println("{" + aH[1][j] + "," + 
                    aH[2][j] + "}" );
            }
        }
    }
}
